//
// Generated by SwagGen
// https://github.com/yonaskolb/SwagGen
//

import Foundation
import JSONUtilities

extension API.ApiVersion {

    /** Permet la vérification de la version de l'application afin de forcer la MAJ */
    public enum GetApiVersionNeedUpdate {

        public static let service = APIService<Response>(id: "getApiVersionNeedUpdate", tag: "Api Version", method: "GET", path: "/apiVersion/needUpdate", hasBody: false)

        public final class Request: APIRequest<Response> {

            public struct Options {

                public var currentVersion: String

                public init(currentVersion: String) {
                    self.currentVersion = currentVersion
                }
            }

            public var options: Options

            public init(options: Options) {
                self.options = options
                super.init(service: GetApiVersionNeedUpdate.service)
            }

            /// convenience initialiser so an Option doesn't have to be created
            public convenience init(currentVersion: String) {
                let options = Options(currentVersion: currentVersion)
                self.init(options: options)
            }

            public override var parameters: [String: Any] {
                var params: JSONDictionary = [:]
                params["currentVersion"] = options.currentVersion
                return params
            }
        }

        public enum Response: APIResponseValue, CustomStringConvertible, CustomDebugStringConvertible {
            public typealias SuccessType = Version

            /** Succes */
            case status200(Version)

            public var success: Version? {
                switch self {
                case .status200(let response): return response
                }
            }

            public var response: Any {
                switch self {
                case .status200(let response): return response
                }
            }

            public var statusCode: Int {
                switch self {
                case .status200: return 200
                }
            }

            public var successful: Bool {
                switch self {
                case .status200: return true
                }
            }

            public init(statusCode: Int, data: Data) throws {
                switch statusCode {
                case 200: self = try .status200(JSONDecoder.decode(data: data))
                default: throw APIError.unexpectedStatusCode(statusCode: statusCode, data: data)
                }
            }

            public var description: String {
                return "\(statusCode) \(successful ? "success" : "failure")"
            }

            public var debugDescription: String {
                var string = description
                let responseString = "\(response)"
                if responseString != "()" {
                    string += "\n\(responseString)"
                }
                return string
            }
        }
    }
}
